//FFSubmenu=GPS
//FFName=RestoreGPS
//
// (C) 2010 Heinz Hfling
// Version 1.1 7.1.2010
// Arbeitet mit RestoreGPS.js zusammen.
// ablauffhig ab Fixfoto V2.85 B:60
// Fixfoto: http://www.j-k-s.com
//


/*@cc_on @*/
/*@set @debon = 1; @*/
var debuger=null;
/*@if (@debon >0) @*/
function Outdebug(s)
{  if (debuger!=null) debuger.Outdebug(s); }
try
   { 
    var debuger = new ActiveXObject("FFExtHH.Debug2"); 
    if( debuger.Debug_Findserver() != 0) 
      debuger.Visible=1;  
    var s;
    s = "#T "; // Build string with necessary info.
    s += ScriptEngine() + " Version ";
    s += ScriptEngineMajorVersion() + ".";
    s += ScriptEngineMinorVersion() + ".";
    s += ScriptEngineBuildVersion();
    s += " FFExtHH Version "+ (debuger.GetVersion()/100);
    Outdebug(s); 
   }
catch(e) {}
/*@else @*/
function Outdebug(s) {}
/*@end @*/



var IsSetter = false;
var savegpskey = "SAVE_GPS_POS";
var dlg="";
var bname="";
var selcnt = 0;
var sel1name ="";

var kors = new Array();


//-------------------------------

var g_aborted = false;
var numprocess =0;
var maxprocess = 0;
var isOpenFort = false;

function Fortschritt(meld, incprocess,  imidx)
{
 if ( !isOpenFort)
   return;
 ff_sleep(2);  
 
 if(imidx>=0)
 {  
   FF_SetControl("Fortschritt..","vorschau",0);
 } 
 if( incprocess!=0 ) 
  {
   numprocess = numprocess + incprocess;
   FF_SetControl("Fortschritt..","prog",(100/maxprocess*(numprocess+1)));
  }
 if( meld!="") 
  FF_SetControl("Fortschritt..","meld",meld);
 var key=FF_CheckKey();
 if (key==27)
  {
   if (FF_MessageBox("Function abrechen?",4)==6)
      g_aborted=true;
  }
 erg=FF_RefreshDialog("Fortschritt..");
 if ( (erg=="CANCEL") || (erg=="Abbruch" ) )      
     g_abored=true;
 return g_aborted;
}

//======================================================================================
function OpenFortschritt(prz100cnt)
{
//** Start Dialog Fortschritt.. **
FF_AddDialog("Fortschritt..",194,61);
FF_AddControl("Fortschritt..","prog","PROGRESS",65,3,126,8);
FF_AddControl("Fortschritt..","meld","SLEDIT",66,15,125,10);
FF_AddControl("Fortschritt..","vorschau","IMAGE",1,1,60,60);
FF_SetControlStyle("Fortschritt..","meld",2048);
FF_AddControl("Fortschritt..","Abbruch mit ESC-Taste","STATIC",101,37,59,10);
//** End Dialog Fortschritt.. **
 g_aborted = false;
 numprocess =0;
 maxprocess = prz100cnt;
 FF_SetControl("Fortschritt..","prog",0);
 FF_SetControl("Fortschritt..","meld","");
 FF_OpenDialog("Fortschritt..");
 isOpenFort = true;
}

function CloseFortschritt()
{
 if(isOpenFort)
   FF_CloseDialog("Fortschritt..");
 isOpenFort = false;
}   



var SS_CENTER = 1;
function InputBox(dd,title,preset)
{
	var text;
	FF_AddDialog(dd,170,44);
	FF_AddControl(dd,title,"STATIC",4,2,162,12);
	FF_SetControlStyle(dd,title,SS_CENTER);
	FF_AddControl(dd,"text","SLEDIT",4,14,162,10);
	FF_SetControl(dd,"text",preset);
	FF_AddControl(dd,"OK","BUTTON",4,28,40,12);
	FF_AddControl(dd,"Abbrechen","BUTTON",106,28,40,12);
	FF_ActivateControl(dd,"text");
	for(;;)
	{
		switch(FF_ShowDialog(dd))
		{
		case "text" : FF_ActivateControl(dd,"Ok"); 
			         break;
		case "OK":	text = FF_GetControl(dd,"text");
  				    FF_CloseDialog(dd); 
			     	return text;
		default:	FF_CloseDialog(dd); 
			        return preset;
		}
	}
}
	

function Class_Kor(aName)
{
 this.lat="";
 this.lon="";
 this.alt="";
 this.text="";
 this.name = aName;    // "1".."9"
 this.dirty = false;

 this.SaveToReg = function()
 {
  if(this.dirty)
    FF_WriteProfile(savegpskey,"Pos_" + this.name, this.lat+"|"+this.lon+"|"+this.alt+"|"+this.text);
  this.dirty=false;
 }
 this.LoadFromReg = function()
 {
  var ss = FF_GetProfile(savegpskey,"Pos_" + this.name)+"||||";
  var s = ss.split("|");
  this.lat = s[0];
  this.lon = s[1];
  this.alt = s[2];
  this.text = s[3];
 }
 this.ToDialog = function()
 {
  ff_setControl(dlg,"text"+this.name , this.text);
  ff_setControl(dlg,"kor"+this.name , this.lat+" "+this.lon+" "+this.alt);
 }
 this.FromExif = function()
 {
  this.lat = FF_GetExifTag("Latitude");
  this.lon = FF_GetExifTag("Longitude");
  this.alt = FF_GetExifTag("Altitude");
  this.text = InputBox("Kommentar zur Kordiante","Kommentar zu: "+this.lat+" "+this.lon
                       ,this.text);
  this.dirty = true;
  if( this.text == "") 
    this.clear();
 }
 this.clear = function()
 {
  this.lat="";
  this.lon="";
  this.alt="";
  this.text="";
  this.dirty=true;
 }
 this.ToExif = function(filename,over)
 {
  if(!FF_HasExif() )
      FF_CreateExif();
  if( over || (FF_GetExifTag("Latitude")=="") )     
  {
    Outdebug("Set: <" + this.lat + "> <" + this.lon + "> <" + this.alt+">");
    if( this.lat=="")
         FF_SetExifTag("Latitude","N 0.0  0.0' 0.0\"");
    else 
        FF_SetExifTag("Latitude",this.lat);
    if( this.lon=="")
         FF_SetExifTag("Longitude","E 0.0  0.0' 0.0\"");
    else
        FF_SetExifTag("Longitude",this.lon);
    FF_SetExifTag("Altitude",this.alt);
    FF_SaveExif(filename);
    Outdebug("Setet:" + FF_getExifTag("Latitude") + " " + FF_GetExifTag("Longitude")+ " " + FF_GetExifTag("Altitude") );
  }
 }
 
}


function Selpos(r)
{
 var nr = parseInt(r.substr(1,1),10);
 if( isNaN(nr) ) 
   return r;

 if(IsSetter)
  {
   kors[nr].FromExif();
   kors[nr].ToDialog();
   return r;
  }
  else 
  {
   var cnt;
   OpenFortschritt(FF_GetImageCount());
   try
    {
     for (cnt=0; cnt<FF_GetImageCount(); cnt++)
      {
       if( g_aborted ) break;
       var f = FF_GetImageName(cnt);
       Outdebug(f);
       FF_LoadExif(f);
       FF_LoadThumb(f);
       Fortschritt(f,1,0);
       kors[nr].ToExif(f, (FF_GetControl(dlg,"cbOver")!=0 ));
      }
     }
   finally
    {
     CloseFortschritt();
    }   
   if( g_aborted)
    FF_MessageBox("Funktion abgebrochen.",1); 
   return "&Ok";
  }
}

function main()
{
//** Start Dialog Save/Restore GPS **
FF_AddDialog("Save/Restore GPS",288,143);
FF_AddControl("Save/Restore GPS","&1","BUTTON",8,2,14,10);
FF_AddControl("Save/Restore GPS","kor1","SLEDIT",139,2,145,10);
FF_SetControlStyle("Save/Restore GPS","kor1",2048);
FF_AddControl("Save/Restore GPS","text1","SLEDIT",27,2,106,10);
FF_SetControlStyle("Save/Restore GPS","text1",2048);
FF_AddControl("Save/Restore GPS","&2","BUTTON",8,14,14,10);
FF_AddControl("Save/Restore GPS","kor2","SLEDIT",139,14,145,10);
FF_SetControlStyle("Save/Restore GPS","kor2",2048);
FF_AddControl("Save/Restore GPS","text2","SLEDIT",27,14,106,10);
FF_SetControlStyle("Save/Restore GPS","text2",2048);
FF_AddControl("Save/Restore GPS","&3","BUTTON",8,26,14,10);
FF_AddControl("Save/Restore GPS","kor3","SLEDIT",139,26,145,10);
FF_SetControlStyle("Save/Restore GPS","kor3",2048);
FF_AddControl("Save/Restore GPS","text3","SLEDIT",27,26,106,10);
FF_SetControlStyle("Save/Restore GPS","text3",2048);
FF_AddControl("Save/Restore GPS","&4","BUTTON",8,38,14,10);
FF_AddControl("Save/Restore GPS","kor4","SLEDIT",139,38,145,10);
FF_SetControlStyle("Save/Restore GPS","kor4",2048);
FF_AddControl("Save/Restore GPS","text4","SLEDIT",27,38,106,10);
FF_SetControlStyle("Save/Restore GPS","text4",2048);
FF_AddControl("Save/Restore GPS","&5","BUTTON",8,50,14,10);
FF_AddControl("Save/Restore GPS","kor5","SLEDIT",139,50,145,10);
FF_SetControlStyle("Save/Restore GPS","kor5",2048);
FF_AddControl("Save/Restore GPS","text5","SLEDIT",27,50,106,10);
FF_SetControlStyle("Save/Restore GPS","text5",2048);
FF_AddControl("Save/Restore GPS","&6","BUTTON",8,62,14,10);
FF_AddControl("Save/Restore GPS","kor6","SLEDIT",139,62,145,10);
FF_SetControlStyle("Save/Restore GPS","kor6",2048);
FF_AddControl("Save/Restore GPS","text6","SLEDIT",27,62,106,10);
FF_SetControlStyle("Save/Restore GPS","text6",2048);
FF_AddControl("Save/Restore GPS","&7","BUTTON",8,74,14,10);
FF_AddControl("Save/Restore GPS","kor7","SLEDIT",139,74,145,10);
FF_SetControlStyle("Save/Restore GPS","kor7",2048);
FF_AddControl("Save/Restore GPS","text7","SLEDIT",27,74,106,10);
FF_SetControlStyle("Save/Restore GPS","text7",2048);
FF_AddControl("Save/Restore GPS","&8","BUTTON",8,86,14,10);
FF_AddControl("Save/Restore GPS","kor8","SLEDIT",139,86,145,10);
FF_SetControlStyle("Save/Restore GPS","kor8",2048);
FF_AddControl("Save/Restore GPS","text8","SLEDIT",27,86,106,10);
FF_SetControlStyle("Save/Restore GPS","text8",2048);
FF_AddControl("Save/Restore GPS","&9","BUTTON",8,98,14,10);
FF_AddControl("Save/Restore GPS","kor9","SLEDIT",139,98,145,10);
FF_SetControlStyle("Save/Restore GPS","kor9",2048);
FF_AddControl("Save/Restore GPS","text9","SLEDIT",27,98,106,10);
FF_SetControlStyle("Save/Restore GPS","text9",2048);
FF_AddControl("Save/Restore GPS","info","EDIT",6,113,243,17);
FF_SetControlStyle("Save/Restore GPS","info",2048);
FF_AddControl("Save/Restore GPS","Save/Restore GPS V1.0  2010 Heinz Hfling","STATIC",6,132,119,9);
FF_AddControl("Save/Restore GPS","cbOver","BOOL",133,133,8,8);
FF_AddControl("Save/Restore GPS","Vorhandene GPS Kord. berschreiben","STATIC",143,131,94,11);
FF_AddControl("Save/Restore GPS","&Ok","BUTTON",252,113,32,17);
//** End Dialog Save/Restore GPS **

dlg="Save/Restore GPS";
var r;

for(i=1; i<=9; i++)
 {
  kors[i] = new Class_Kor(""+i);
  kors[i].LoadFromReg();
  kors[i].ToDialog();
}
FF_SetControl(dlg,"cbOver", FF_GetProfile(savegpskey,"cbOver"));
FF_EnableControl(dlg,"cbOver",IsSetter==false);
if( IsSetter )
  FF_SetControl(dlg,"info","Drcken Sie <1> bis <9> um die Kordinaten des aktuellen Bildes unter dieser Nr abzuspeichern.\r\n"+
                           "Zum lschen des Eintrages bitte das Kommentarfeld leer eingeben.");
else
  FF_SetControl(dlg,"info","Drcken Sie <1> bis <9> um die gespeicherte Kordinate im aktuellen Bild\r\noder den selektieren Bildern abzuspeichern.");

FF_ActivateControl(dlg,"&Ok");
 for(;;)
 {
  r = FF_ShowDialog(dlg);
  switch(r) 
   {
    default : r=Selpos(r); break;
   }
  if( (r=="CANCEL") || (r=="&Ok") ) 
    break;
 }
 if( r=="&Ok" )
  for(i=1; i<=9; i++)
    kors[i].SaveToReg();
 FF_WriteProfile(savegpskey,"cbOver",FF_GetControl(dlg,"cbOver"));
 
 FF_CloseDialog(dlg);
}


if( FF_GetParam() == "SAVE_GPS")
 IsSetter=true;

bname = Ff_GetImageName(-1); // Current Working Image
selcnt = FF_GetImageCount();
sel1name =(selcnt<1) ? "" : ff_GetImageName(0); // = bname wenn geladenes bild sonst erstes einer Series

if( IsSetter==false) 
 { // wenn es RestoreGPS ist, dann ist es erlaubt mehrer Bilder zu markieren
  if (bname != "") FF_PushImage();
  main();
  if (bname  != "") FF_PopImage();
  // restore Exif von bname weil evtl. mit LoadExif andere geladen wurden
  FF_LoadExif(bname);
 }
  else
 {
  if( selcnt>1)
    FF_MessageBox("Bitte nur ein Bild laden.\r\n Keine Multiseltion!",0)
  else if( bname=="") 
    FF_MessageBox("Kein Bild geladen!",0)
  else if( !FF_HasExif() )
    FF_MessageBox("Keine Exif-Daten im Bild vorhanden",0)
  else
    main();
 }
 
